/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */


package alefpp.core;

import java.util.Hashtable;

/**
 * ABlock class is a block statement "{" ... "}"
 * @author Adrabi Abderrahim
 * @version 1.3
 */

public class ABlock extends Scope{

	private Hashtable<String,AStatement> children	=	null;
	private AStatement parent						=	null;
	
	public ABlock(){
		this.children	=	new Hashtable<String,AStatement>();
	}
	
	@Override
	public boolean child(String $1, AStatement $2) {
		$2.parent(this);
		return this.children.put($1, $2) != null;
	}

	@Override
	public AStatement child(String $1) {
		if( this.children.containsKey($1) ){
			return this.children.get($1);
		}
		else if( this.parent instanceof Scope ){
			Scope scope = (Scope)this.parent;
			if( scope.existsChild($1) ){
				return scope.child($1);
			}
		}
		return null;
	}

	@Override
	public boolean existsChild(String $1) {
		if( this.children.containsKey($1) ){
			return true;
		}
		else if( this.parent instanceof Scope ){
			return ((Scope)this.parent).existsChild($1);
		}
		return false;
	}

	@Override
	public AStatement localChild(String $1) {
		return this.children.get( $1 );
	}

	@Override
	public boolean localExistsChild(String $1) {
		return this.children.containsKey( $1 );
	}

	public AStatement parent() {
		return this.parent;
	}

	public boolean parent(AStatement $1) {
		return (this.parent = $1) != null ;
	}

}
