/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.core;

/**
 * This class is class base for "goto" statement in "jump" statement
 * 
 * jump [EXPRESSION]
 * 	goto [EXPRESSION] : [DO ... SOMETHING]
 *  goto [EXPRESSION] : [DO ... SOMETHING]
 *  goto [EXPRESSION] : [DO ... SOMETHING]
 * ;
 * 
 * "goto" is considirated like a block, for variables visibilty and 
 * minipulation.
 * 
 * @author Adrabi Abderrahim
 * @version 1.1
 */
public class AGoto extends ABlock{
	
	/**
	 * Test Expression is a result for "goto [Expression]"
	 * for testing it with "jump [Expression]"
	 */
	private Object testExpression = null;
	
	/**
	 * Execution Block is "to do" statement has be executed
	 * if "jump [Expression]" eq "goto [Expression]"  
	 */
	private Object executionBlock = null;

	public Object getExecutionBlock() {
		return executionBlock;
	}

	public void setExecutionBlock(Object executionBlock) {
		this.executionBlock = executionBlock;
	}

	public Object getTestExpression() {
		return testExpression;
	}

	public void setTestExpression(Object testExpression) {
		this.testExpression = testExpression;
	}
	
	
}
