/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */


package alefpp.core;

/**
 * This class for storing an arguments with types for Alef++ subroutines
 * or Java methods like :
 * Subroutine[ Value_1, Value_2, ...]
 * my $var int &lt- value; 
 * 
 * this store a name, value and type of argument but don't store a class 
 * type of type just type name.
 * 
 * @author Adrabi Abderrahim
 * @version 1.1
 */

public class AValue extends AStatement{

	private String name	=	null;
	private String type	=	null;
	private Object value=	null;
	
	/**
	 * 
	 * @param $1 (String : Argument Name)
	 * @param $2 (String : Argument Type)
	 */
	public AValue(String $1, String $2){
		this.name = $1;
		this.type = $2;
		this.value = new Walo();
	}
	
	/**
	 * 
	 * @param $1 (String : Argument Name)
	 * @param $2 (String : Argument Type)
	 * @param $3 (Object : Argument Value)
	 */
	public AValue(String $1, String $2, Object $3){
		this.name	= $1;
		this.type	= $2;
		this.value	= $3;
	}
	
	public Object getValue() {
		return value;
	}

	public void setValue(Object value) {
		this.value = value;
	}

	public String getName() {
		return name;
	}

	/**
	 * Get Value type
	 * @return
	 */
	public String getType() {
		return type;
	}
	
	/**
	 * Set Value type
	 * @param $1
	 */
	public void setType(String $1){
		this.type = $1 ;
	}
	
	public AStatement parent() {
		return null;
	}

	public boolean parent(AStatement $1) {
		return false;
	}
	
	public String toString(){
		return this.value.toString();
	}
}
