/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.core;

import java.util.Hashtable;

import alefpp.reflect.Reflection;
import alefpp.tools.Types;

/**
 * This class is responsable for load and executing a external methods
 * (plug-ins or add-on methods)
 * 
 * @author Adrabi Abderrahim
 * @version 1.1
 */
public class Methods {
	
	public static Hashtable<String,String> methods = new Hashtable<String,String>();
	
	static{
		try {
			
			Class.forName("alefpp.plugins.Loader");
			
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * Standare Alef++ methods plug-ins entry point
	 * is like :
	 * 		public static void forge(String,Object,Object[])
	 * 		{
	 * 			...
	 * 		}
	 * @param $1 (String  : Method Name)
	 * @param $2 (Object  : Interpreter)
	 * @param $3 (AValue[]: Paramerts)
	 * @return
	 * @throws Exception
	 */
	public static Object forge(String $1 , Object $2 ,AValue[] $3 ) throws Exception{
		
		if( methods.containsKey( $1 ) ){
			String className = methods.get( $1 ) ;
			String[] methodsName = new String[$3.length];
			
			for( int index = 0 ; index < $3.length ; index++ ){
				methodsName[ index ] = $3[ index ].toString();
			}
			
			AValue[] args = new AValue[]{
					new AValue(null, "java.lang.String"		,	$1),
					new AValue(null, "java.lang.Object"		,	$2),
					new AValue(null, "[Ljava.lang.Object;"	,	methodsName)
			};
			if( Reflection.existsSubroutine( className, "forge" , args ) ){
				Object tmp = Reflection.invokeStaticSubroutine( className , "forge", args); 
				return new AValue( null, Types.getObjectType( tmp ) , tmp );
			}
			else{
				throw new Exception( "'Object forge(String,Object,String[])' method not found in " + className );
			}
		}
		
		throw new Exception();
	}
}
