/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * License :: file Artistic.htm
 */


package alefpp.core;

/**
 * Base of all scopes and block in Alef++ (simple blocks and subroutines ... )
 * @author Adrabi Abderrahim
 * @version 1.3
 */

public abstract class Scope extends AStatement{
	
	/**
	 * Set scope childen
	 * @param $1 (child name)
	 * @param $2 (child object)
	 * @return
	 */
	public boolean child(String $1 , AStatement $2){
		throw new java.lang.UnsupportedOperationException();
	}
	
	/**
	 * Get a child from local scope or parent of this scope 
	 * @param $1
	 * @return
	 */
	public AStatement child( String $1){
		throw new java.lang.UnsupportedOperationException();
	}
	
	/**
	 * Find exists child in alef++ parent statement 
	 * @param $1
	 * @return
	 */
	public boolean existsChild(String $1){
		throw new java.lang.UnsupportedOperationException();
	}
	
	/**
	 * Get a child from local scope
	 * @param $1
	 * @return
	 */
	public AStatement localChild( String $1){
		throw new java.lang.UnsupportedOperationException();
	}
	
	/**
	 * Find exists child in alef++ parent statement 
	 * @param $1
	 * @return
	 */
	public boolean localExistsChild(String $1){
		throw new java.lang.UnsupportedOperationException();
	}
}
