/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.core.exceptions;

/**
 * Duplicate Local Variable Exception for duplicating name of varaible in scope
 * @author Adrabi Abderrahim
 * @version 1.1
 */
public class DuplicateLocalVariableException extends Exception {

	private static final long serialVersionUID = 1L;
	
	/**
	 * 
	 * @param $1 (String : Variable Name)
	 * @param $2 (Long[] : Variable Position)
	 */
	public DuplicateLocalVariableException(String $1 , long[] $2){
		super("Duplicate local variable " + $1 + " @[" + $2[0] + "," + $2[1] + "]");
	}

}
