/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.core.exceptions;

/**
 * Missing label exception is a class exception for no founded lables in loop controls
 * last and next.
 * @author Adrabi Abderrahim
 * @version 1.1
 */
public class MissingLabelException extends Exception {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	/**
	 * Missing label exception
	 * @param $1 (String : Label Name)
	 * @param $2 (long[] : Position)
	 */
	public MissingLabelException( String $1, long[] $2 ){
		super( "The label " + $1 + " is missing @[" + $2[0] + ", " + $2[1] + "]" );
	}
	
}
