/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.core.exceptions;

import java.util.Arrays;

/**
 * Undefined Subroutine Exception for non existens subroutines
 * @author Adrabi Abderrahim
 * @version 1.3
 */
public class UndefinedSubroutineException extends Exception {

	private static final long serialVersionUID = 1L;
	
	/**
	 * 
	 * @param $1 (String : Subroutine Name)
	 * @param $2 (Object : From Type)
	 * @param $3 (Long[] : Position)
	 */
	public UndefinedSubroutineException(String $1, Object $2 , String[] $3 , long[] $4 ){
		super( "The subroutine " + $1 + " " + 
				Arrays.toString( $3 ) + 
				" is undefined for the type " + 
				($2 instanceof Class ? ((Class)$2).getName() : $2.getClass().getName() ) + 
				" @" + Arrays.toString( $4 ) );
	}

}
