/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.interpreter;

/**
 * 
 * @author Adrabi Abderrahim
 * @version 1.6
 */

public class NativeTypes {
	
	/**
	 * Test is String
	 * @param $1
	 * @return
	 */
	public static boolean isString(String $1){
		return $1.endsWith("'") && $1.startsWith("'");
	}
	
	/**
	 * Test is an Byte
	 * @param $1
	 * @return
	 */
	public static boolean isByte(String $1){
		try{
			if( $1.toLowerCase().startsWith("0x") ){
				$1 =  $1.toLowerCase().replace("0x", "");
				Byte.parseByte($1,16);
			}
			else if( $1.toLowerCase().startsWith("0o") ){
				$1 =  $1.toLowerCase().replace("0o", "");
				Byte.parseByte($1,8);
			}
			else if( $1.toLowerCase().startsWith("0b") ){
				$1 =  $1.toLowerCase().replace("0b", "");
				Byte.parseByte($1,2);
			}
			else{
				Byte.parseByte($1);
			}
			return true;
		}catch (Exception e){ }
		return false;
	}
	
	
	/**
	 * Test is an Integer
	 * @param $1
	 * @return
	 */
	public static boolean isInt(String $1){
		try{
			if( $1.toLowerCase().startsWith("0x") ){
				$1 =  $1.toLowerCase().replace("0x", "");
				Integer.parseInt($1,16);
			}
			else if( $1.toLowerCase().startsWith("0o") ){
				$1 =  $1.toLowerCase().replace("0o", "");
				Integer.parseInt($1,8);
			}
			else if( $1.toLowerCase().startsWith("0b") ){
				$1 =  $1.toLowerCase().replace("0b", "");
				Integer.parseInt($1,2);
			}
			else{
				Integer.parseInt($1);
			}
			return true;
		}catch (Exception e){ }
		return false;
	}
	
	/**
	 * Test is a Long
	 * @param $1
	 * @return
	 */
	public static boolean isLong(String $1){
		try{
			$1 = $1.toLowerCase().endsWith("l") ? $1.toLowerCase().replace("l", "") : $1;
			if( $1.toLowerCase().startsWith("0x") ){
				$1 =  $1.toLowerCase().replace("0x", "");
				Long.parseLong($1,16);
			}
			else if( $1.toLowerCase().startsWith("0o") ){
				$1 =  $1.toLowerCase().replace("0o", "");
				Long.parseLong($1,8);
			}
			else if( $1.toLowerCase().startsWith("0b") ){
				$1 =  $1.toLowerCase().replace("0b", "");
				Long.parseLong($1,2);
			}
			else{
				Long.parseLong($1);
			}
			
			return true;
		}catch (Exception e){ }
		return false;
	}
	
	/**
	 * Test is a Double
	 * @param $1
	 * @return
	 */
	public static boolean isDouble(String $1){
		try{
			Double.parseDouble($1);
			return true;
		}catch (Exception e){ }
		return false;
	}
	
	/**
	 * Test is a Boolean
	 * @param $1
	 * @return
	 */
	public static boolean isBoolean(String $1){
		try{
			Boolean.parseBoolean($1);
			return true;
		}catch (Exception e){ }
		return false;
	}
}
