/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.main;

import java.io.File;

import alefpp.interpreter.Interpret;
//import alefpp.dumper.Dump;
import alefpp.parser.AlefppParser;

/**
 * Alef++ Class Main
 * @author Adrabi Abderrahim
 * @version 1.1
 */

public class Main {
	public static void main(String [] $)
	  {
	    AlefppParser parser;
	    try
	    {
	      if ($.length == 0) 
	      throw new Exception("Error, file dons't exists !");
	      else if (!new File($ [0]).exists()) 
	      throw new Exception("Error, reading file : " + $ [0] + " !");
	      parser = new AlefppParser(new java.io.FileInputStream($ [0]));
	      
	      /*****************************************************************
	      //For Dumper Active this
	      Dump dump = new Dump();
	      System.out.println(dump.visit(parser.Alefpp()));
	      *****************************************************************/
	      
	      new Interpret().visit(parser.Alefpp() , $);
	    }
	    catch (Throwable e)
	    {
	      e.printStackTrace();
	    }
	  }
}
