//
// Generated by JTB 1.3.2
//

package alefpp.parser.visitor;
import alefpp.parser.syntaxtree.*;
import java.util.*;

/**
 * Provides default methods which visit each node in the tree in depth-first
 * order.  Your visitors may extend this class.
 */
@SuppressWarnings("all")
public class DepthFirstVisitor implements Visitor {
   //
   // Auto class visitors--probably don't need to be overridden.
   //
   public void visit(NodeList n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeListOptional n) {
      if ( n.present() )
         for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
            e.nextElement().accept(this);
   }

   public void visit(NodeOptional n) {
      if ( n.present() )
         n.node.accept(this);
   }

   public void visit(NodeSequence n) {
      for ( Enumeration<Node> e = n.elements(); e.hasMoreElements(); )
         e.nextElement().accept(this);
   }

   public void visit(NodeToken n) { }

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( UseStatement() )*
    * f1 -> ( EmptyStatement() | VariableDeclaration() ";" | SubroutineDeclaration() | Module() )*
    * f2 -> ( Main() )?
    * f3 -> <EOF>
    */
   public void visit(Alefpp n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> "use"
    * f1 -> <IDENTIFIER>
    * f2 -> ( "." ( <IDENTIFIER> | "*" ) )*
    * f3 -> [ ":" <STRING_LITERAL> ]
    * f4 -> ";"
    */
   public void visit(UseStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> ";"
    */
   public void visit(EmptyStatement n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> <SPCIAL_SCALAR>
    *       | <SCALAR>
    *       | "$"
    */
   public void visit(Scalar n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "<-"
    * f1 -> Expression()
    */
   public void visit(ScalarAssign n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "my"
    * f1 -> [ "`" ]
    * f2 -> <SCALAR>
    * f3 -> [ FullIdentifier() ]
    * f4 -> ( "@" | "%" )*
    * f5 -> [ ScalarAssign() ]
    */
   public void visit(VariableDeclaration n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> "["
    * f1 -> [ ArgumentList() ]
    * f2 -> "]"
    */
   public void visit(Arguments n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Expression()
    * f1 -> ( "," Expression() )*
    */
   public void visit(ArgumentList n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "#"
    * f1 -> ( ModuleSubroutineCalling() | <INTEGER_LITERAL> | Expression() )
    */
   public void visit(ArrayIndex n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "\\"
    * f1 -> ( <IDENTIFIER> | Expression() )
    */
   public void visit(HashKey n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "["
    * f1 -> ( Expression() ( "," Expression() )* )?
    * f2 -> "]"
    */
   public void visit(Array n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "{"
    * f1 -> ( ( <IDENTIFIER> | Expression() ) "=>" Expression() ( "," ( <IDENTIFIER> | Expression() ) "=>" Expression() )* )?
    * f2 -> "}"
    */
   public void visit(Hash n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "->"
    * f1 -> ( <IDENTIFIER> [ Arguments() ] | Scalar() [ ArrayIndex() | HashKey() ] )
    * f2 -> ( MemberAccess() )*
    */
   public void visit(MemberAccess n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ( "." <IDENTIFIER> )*
    */
   public void visit(FullIdentifier n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> FullIdentifier()
    * f1 -> ( ( "::" )? Arguments() )?
    * f2 -> [ MemberAccess() ]
    */
   public void visit(ModuleSubroutineCalling n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> CastStatement()
    *       | ReferenceStatement()
    *       | XiSubroutine()
    *       | ConditionalExpression()
    *       | ConditionalOrExpression()
    *       | AdditiveExpression()
    *       | MultiplicativeExpression()
    *       | BitwiseExpression()
    *       | ShiftExpression()
    *       | Array()
    *       | Hash()
    *       | ValuesExpression()
    */
   public void visit(Expression n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "to"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public void visit(CastStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "ref"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public void visit(ReferenceStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> ( "+" | "-" )
    * f1 -> ( Expression() )+
    */
   public void visit(AdditiveExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "*" | "/" | "%" | "//" | "**" )
    * f1 -> ( Expression() )+
    */
   public void visit(MultiplicativeExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "&" | "|" )
    * f1 -> ( Expression() )+
    */
   public void visit(BitwiseExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "<<" | ">>" )
    * f1 -> ( Expression() )+
    */
   public void visit(ShiftExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ConditionalAndExpression()
    * f1 -> ( "||" ConditionalAndExpression() )*
    */
   public void visit(ConditionalOrExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> EqualityExpression()
    * f1 -> ( "&&" EqualityExpression() )*
    */
   public void visit(ConditionalAndExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> RelationalExpression()
    * f1 -> ( ( "==" | "!=" ) RelationalExpression() )*
    */
   public void visit(EqualityExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ExclusiveOrExpression()
    * f1 -> ( ( "<" | ">" | "<=" | ">=" ) ExclusiveOrExpression() )*
    */
   public void visit(RelationalExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ValuesExpression()
    * f1 -> ( "^" ValuesExpression() )*
    */
   public void visit(ExclusiveOrExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "walo"
    */
   public void visit(WaloExpression n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> WaloExpression()
    *       | "true"
    *       | "false"
    *       | <STRING_LITERAL>
    *       | <INTEGER_LITERAL>
    *       | <FLOATING_POINT_LITERAL>
    *       | PreInDeCrementExpression()
    *       | InDeCrementExpression()
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ]
    *       | ModuleSubroutineCalling() [ ScalarAssign() ]
    *       | "(" Expression() ")" [ MemberAccess() ]
    *       | "!" Expression()
    */
   public void visit(ValuesExpression n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> ( "++" | "--" )
    * f1 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    */
   public void visit(PreInDeCrementExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    * f1 -> ( "++" | "--" )
    */
   public void visit(InDeCrementExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "="
    * f1 -> Expression()
    * f2 -> ","
    * f3 -> ValuesExpression()
    * f4 -> [ "," ValuesExpression() ]
    */
   public void visit(ConditionalExpression n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> Scalar()
    * f1 -> ( ArrayIndex() | HashKey() )*
    */
   public void visit(ScalarValue n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "eval"
    * f1 -> BlockStatement()
    * f2 -> ( "error" "(" ( <SCALAR> | "my" <SCALAR> [ FullIdentifier() ] ) ")" BlockStatement() )+
    * f3 -> [ "end" BlockStatement() ]
    */
   public void visit(EvalStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> "goto"
    * f1 -> Expression()
    * f2 -> ":"
    * f3 -> BlockStatement()
    */
   public void visit(GotoStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> "miss"
    * f1 -> ":"
    * f2 -> BlockStatement()
    */
   public void visit(MissStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "jump"
    * f1 -> Expression()
    * f2 -> ( GotoStatement() )+
    * f3 -> [ MissStatement() ]
    */
   public void visit(JumpStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> Expression()
    * f1 -> "!loop"
    * f2 -> BlockStatement()
    */
   public void visit(DoWhileStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> Expression()
    * f1 -> "loop"
    * f2 -> BlockStatement()
    */
   public void visit(WhileStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> EachInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "each"
    * f4 -> BlockStatement()
    */
   public void visit(EachStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ]
    *       | ScalarValue() [ MemberAccess() ]
    *       | ModuleSubroutineCalling()
    */
   public void visit(EachInit n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> GoInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "go"
    * f4 -> [ "(" Expression() ")" ]
    * f5 -> BlockStatement()
    */
   public void visit(GoStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> Expression()
    * f1 -> "=>"
    * f2 -> BlockStatement()
    * f3 -> [ "," BlockStatement() ]
    */
   public void visit(IfStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ] [ ScalarAssign() ]
    *       | ValuesExpression()
    */
   public void visit(GoInit n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ":"
    */
   public void visit(Label n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "next"
    * f1 -> [ <IDENTIFIER> ]
    */
   public void visit(Next n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "last"
    * f1 -> [ <IDENTIFIER> ]
    */
   public void visit(Last n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> FullIdentifier()
    * f1 -> [ ( "[" )+ | ( "@" | "%" )+ ]
    */
   public void visit(ParameterType n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ":"
    * f1 -> FullIdentifier()
    * f2 -> ( ( "[" )+ | ( "@" | "%" )+ )?
    */
   public void visit(SubroutineType n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "sub"
    * f1 -> <IDENTIFIER>
    * f2 -> [ SubroutineType() ]
    * f3 -> ( "(" [ ParameterType() ( "," ParameterType() )* ] ")" )?
    * f4 -> [ DiesStatement() ]
    * f5 -> Block()
    */
   public void visit(SubroutineDeclaration n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
      n.f5.accept(this);
   }

   /**
    * f0 -> Block()
    * f1 -> Arguments()
    */
   public void visit(XiSubroutine n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "ret"
    * f1 -> Expression()
    * f2 -> ";"
    */
   public void visit(ReturnStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "die"
    * f1 -> Expression()
    */
   public void visit(DieStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> ( "=" FullIdentifier() )+
    */
   public void visit(DiesStatement n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "synchro"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Block()
    */
   public void visit(SynchonizedStatement n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> "main"
    * f1 -> [ DiesStatement() ]
    * f2 -> Block()
    */
   public void visit(Main n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> "{"
    * f1 -> ( BlockStatement() )*
    * f2 -> "}"
    */
   public void visit(Block n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
   }

   /**
    * f0 -> EmptyStatement()
    *       | Block()
    *       | Statement()
    *       | ReturnStatement()
    */
   public void visit(BlockStatement n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> DoWhileStatement()
    *       | WhileStatement()
    *       | EachStatement()
    *       | GoStatement()
    *       | IfStatement()
    *       | Label()
    *       | Last() ";"
    *       | Next() ";"
    *       | VariableDeclaration() ";"
    *       | PreInDeCrementExpression() ";"
    *       | InDeCrementExpression() ";"
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ] ";"
    *       | ModuleSubroutineCalling() [ ScalarAssign() ] ";"
    *       | DieStatement() ";"
    *       | JumpStatement() ";"
    *       | EvalStatement()
    *       | SynchonizedStatement()
    */
   public void visit(Statement n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> "~"
    *       | "+"
    *       | "-"
    *       | "#"
    *       | "must"
    */
   public void visit(Modifier n) {
      n.f0.accept(this);
   }

   /**
    * f0 -> ( Modifier() )*
    * f1 -> "module"
    * f2 -> FullIdentifier()
    * f3 -> ModuleBodyBlock()
    */
   public void visit(Module n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> ( Modifier() )*
    * f1 -> VariableDeclaration()
    */
   public void visit(ModuleVariableDeclaration n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "autoload"
    * f1 -> Block()
    */
   public void visit(ModuleAutoload n) {
      n.f0.accept(this);
      n.f1.accept(this);
   }

   /**
    * f0 -> "init"
    * f1 -> [ "(" [ ParameterType() ( "," ParameterType() )* ] ")" ]
    * f2 -> [ DiesStatement() ]
    * f3 -> Block()
    */
   public void visit(ModuleInit n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> "{"
    * f1 -> ( DollarISA() )?
    * f2 -> ( AtISA() )?
    * f3 -> ( ModuleVariableDeclaration() ";" | SubroutineDeclaration() | ModuleAutoload() | EmptyStatement() | ModuleInit() )*
    * f4 -> "}"
    */
   public void visit(ModuleBodyBlock n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

   /**
    * f0 -> <DOLLARISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ">"
    */
   public void visit(DollarISA n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
   }

   /**
    * f0 -> <ATISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ( "," FullIdentifier() )*
    * f4 -> ">"
    */
   public void visit(AtISA n) {
      n.f0.accept(this);
      n.f1.accept(this);
      n.f2.accept(this);
      n.f3.accept(this);
      n.f4.accept(this);
   }

}
