//
// Generated by JTB 1.3.2
//

package alefpp.parser.visitor;
import alefpp.parser.syntaxtree.*;
import java.util.*;

/**
 * All GJ visitors must implement this interface.
 */

@SuppressWarnings("all")
public interface GJVisitor<R,A> {

   //
   // GJ Auto class visitors
   //

   public R visit(NodeList n, A argu);
   public R visit(NodeListOptional n, A argu);
   public R visit(NodeOptional n, A argu);
   public R visit(NodeSequence n, A argu);
   public R visit(NodeToken n, A argu);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( UseStatement() )*
    * f1 -> ( EmptyStatement() | VariableDeclaration() ";" | SubroutineDeclaration() | Module() )*
    * f2 -> ( Main() )?
    * f3 -> <EOF>
    */
   public R visit(Alefpp n, A argu);

   /**
    * f0 -> "use"
    * f1 -> <IDENTIFIER>
    * f2 -> ( "." ( <IDENTIFIER> | "*" ) )*
    * f3 -> [ ":" <STRING_LITERAL> ]
    * f4 -> ";"
    */
   public R visit(UseStatement n, A argu);

   /**
    * f0 -> ";"
    */
   public R visit(EmptyStatement n, A argu);

   /**
    * f0 -> <SPCIAL_SCALAR>
    *       | <SCALAR>
    *       | "$"
    */
   public R visit(Scalar n, A argu);

   /**
    * f0 -> "<-"
    * f1 -> Expression()
    */
   public R visit(ScalarAssign n, A argu);

   /**
    * f0 -> "my"
    * f1 -> [ "`" ]
    * f2 -> <SCALAR>
    * f3 -> [ FullIdentifier() ]
    * f4 -> ( "@" | "%" )*
    * f5 -> [ ScalarAssign() ]
    */
   public R visit(VariableDeclaration n, A argu);

   /**
    * f0 -> "["
    * f1 -> [ ArgumentList() ]
    * f2 -> "]"
    */
   public R visit(Arguments n, A argu);

   /**
    * f0 -> Expression()
    * f1 -> ( "," Expression() )*
    */
   public R visit(ArgumentList n, A argu);

   /**
    * f0 -> "#"
    * f1 -> ( ModuleSubroutineCalling() | <INTEGER_LITERAL> | Expression() )
    */
   public R visit(ArrayIndex n, A argu);

   /**
    * f0 -> "\\"
    * f1 -> ( <IDENTIFIER> | Expression() )
    */
   public R visit(HashKey n, A argu);

   /**
    * f0 -> "["
    * f1 -> ( Expression() ( "," Expression() )* )?
    * f2 -> "]"
    */
   public R visit(Array n, A argu);

   /**
    * f0 -> "{"
    * f1 -> ( ( <IDENTIFIER> | Expression() ) "=>" Expression() ( "," ( <IDENTIFIER> | Expression() ) "=>" Expression() )* )?
    * f2 -> "}"
    */
   public R visit(Hash n, A argu);

   /**
    * f0 -> "->"
    * f1 -> ( <IDENTIFIER> [ Arguments() ] | Scalar() [ ArrayIndex() | HashKey() ] )
    * f2 -> ( MemberAccess() )*
    */
   public R visit(MemberAccess n, A argu);

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ( "." <IDENTIFIER> )*
    */
   public R visit(FullIdentifier n, A argu);

   /**
    * f0 -> FullIdentifier()
    * f1 -> ( ( "::" )? Arguments() )?
    * f2 -> [ MemberAccess() ]
    */
   public R visit(ModuleSubroutineCalling n, A argu);

   /**
    * f0 -> CastStatement()
    *       | ReferenceStatement()
    *       | XiSubroutine()
    *       | ConditionalExpression()
    *       | ConditionalOrExpression()
    *       | AdditiveExpression()
    *       | MultiplicativeExpression()
    *       | BitwiseExpression()
    *       | ShiftExpression()
    *       | Array()
    *       | Hash()
    *       | ValuesExpression()
    */
   public R visit(Expression n, A argu);

   /**
    * f0 -> "to"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public R visit(CastStatement n, A argu);

   /**
    * f0 -> "ref"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public R visit(ReferenceStatement n, A argu);

   /**
    * f0 -> ( "+" | "-" )
    * f1 -> ( Expression() )+
    */
   public R visit(AdditiveExpression n, A argu);

   /**
    * f0 -> ( "*" | "/" | "%" | "//" | "**" )
    * f1 -> ( Expression() )+
    */
   public R visit(MultiplicativeExpression n, A argu);

   /**
    * f0 -> ( "&" | "|" )
    * f1 -> ( Expression() )+
    */
   public R visit(BitwiseExpression n, A argu);

   /**
    * f0 -> ( "<<" | ">>" )
    * f1 -> ( Expression() )+
    */
   public R visit(ShiftExpression n, A argu);

   /**
    * f0 -> ConditionalAndExpression()
    * f1 -> ( "||" ConditionalAndExpression() )*
    */
   public R visit(ConditionalOrExpression n, A argu);

   /**
    * f0 -> EqualityExpression()
    * f1 -> ( "&&" EqualityExpression() )*
    */
   public R visit(ConditionalAndExpression n, A argu);

   /**
    * f0 -> RelationalExpression()
    * f1 -> ( ( "==" | "!=" ) RelationalExpression() )*
    */
   public R visit(EqualityExpression n, A argu);

   /**
    * f0 -> ExclusiveOrExpression()
    * f1 -> ( ( "<" | ">" | "<=" | ">=" ) ExclusiveOrExpression() )*
    */
   public R visit(RelationalExpression n, A argu);

   /**
    * f0 -> ValuesExpression()
    * f1 -> ( "^" ValuesExpression() )*
    */
   public R visit(ExclusiveOrExpression n, A argu);

   /**
    * f0 -> "walo"
    */
   public R visit(WaloExpression n, A argu);

   /**
    * f0 -> WaloExpression()
    *       | "true"
    *       | "false"
    *       | <STRING_LITERAL>
    *       | <INTEGER_LITERAL>
    *       | <FLOATING_POINT_LITERAL>
    *       | PreInDeCrementExpression()
    *       | InDeCrementExpression()
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ]
    *       | ModuleSubroutineCalling() [ ScalarAssign() ]
    *       | "(" Expression() ")" [ MemberAccess() ]
    *       | "!" Expression()
    */
   public R visit(ValuesExpression n, A argu);

   /**
    * f0 -> ( "++" | "--" )
    * f1 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    */
   public R visit(PreInDeCrementExpression n, A argu);

   /**
    * f0 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    * f1 -> ( "++" | "--" )
    */
   public R visit(InDeCrementExpression n, A argu);

   /**
    * f0 -> "="
    * f1 -> Expression()
    * f2 -> ","
    * f3 -> ValuesExpression()
    * f4 -> [ "," ValuesExpression() ]
    */
   public R visit(ConditionalExpression n, A argu);

   /**
    * f0 -> Scalar()
    * f1 -> ( ArrayIndex() | HashKey() )*
    */
   public R visit(ScalarValue n, A argu);

   /**
    * f0 -> "eval"
    * f1 -> BlockStatement()
    * f2 -> ( "error" "(" ( <SCALAR> | "my" <SCALAR> [ FullIdentifier() ] ) ")" BlockStatement() )+
    * f3 -> [ "end" BlockStatement() ]
    */
   public R visit(EvalStatement n, A argu);

   /**
    * f0 -> "goto"
    * f1 -> Expression()
    * f2 -> ":"
    * f3 -> BlockStatement()
    */
   public R visit(GotoStatement n, A argu);

   /**
    * f0 -> "miss"
    * f1 -> ":"
    * f2 -> BlockStatement()
    */
   public R visit(MissStatement n, A argu);

   /**
    * f0 -> "jump"
    * f1 -> Expression()
    * f2 -> ( GotoStatement() )+
    * f3 -> [ MissStatement() ]
    */
   public R visit(JumpStatement n, A argu);

   /**
    * f0 -> Expression()
    * f1 -> "!loop"
    * f2 -> BlockStatement()
    */
   public R visit(DoWhileStatement n, A argu);

   /**
    * f0 -> Expression()
    * f1 -> "loop"
    * f2 -> BlockStatement()
    */
   public R visit(WhileStatement n, A argu);

   /**
    * f0 -> EachInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "each"
    * f4 -> BlockStatement()
    */
   public R visit(EachStatement n, A argu);

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ]
    *       | ScalarValue() [ MemberAccess() ]
    *       | ModuleSubroutineCalling()
    */
   public R visit(EachInit n, A argu);

   /**
    * f0 -> GoInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "go"
    * f4 -> [ "(" Expression() ")" ]
    * f5 -> BlockStatement()
    */
   public R visit(GoStatement n, A argu);

   /**
    * f0 -> Expression()
    * f1 -> "=>"
    * f2 -> BlockStatement()
    * f3 -> [ "," BlockStatement() ]
    */
   public R visit(IfStatement n, A argu);

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ] [ ScalarAssign() ]
    *       | ValuesExpression()
    */
   public R visit(GoInit n, A argu);

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ":"
    */
   public R visit(Label n, A argu);

   /**
    * f0 -> "next"
    * f1 -> [ <IDENTIFIER> ]
    */
   public R visit(Next n, A argu);

   /**
    * f0 -> "last"
    * f1 -> [ <IDENTIFIER> ]
    */
   public R visit(Last n, A argu);

   /**
    * f0 -> FullIdentifier()
    * f1 -> [ ( "[" )+ | ( "@" | "%" )+ ]
    */
   public R visit(ParameterType n, A argu);

   /**
    * f0 -> ":"
    * f1 -> FullIdentifier()
    * f2 -> ( ( "[" )+ | ( "@" | "%" )+ )?
    */
   public R visit(SubroutineType n, A argu);

   /**
    * f0 -> "sub"
    * f1 -> <IDENTIFIER>
    * f2 -> [ SubroutineType() ]
    * f3 -> ( "(" [ ParameterType() ( "," ParameterType() )* ] ")" )?
    * f4 -> [ DiesStatement() ]
    * f5 -> Block()
    */
   public R visit(SubroutineDeclaration n, A argu);

   /**
    * f0 -> Block()
    * f1 -> Arguments()
    */
   public R visit(XiSubroutine n, A argu);

   /**
    * f0 -> "ret"
    * f1 -> Expression()
    * f2 -> ";"
    */
   public R visit(ReturnStatement n, A argu);

   /**
    * f0 -> "die"
    * f1 -> Expression()
    */
   public R visit(DieStatement n, A argu);

   /**
    * f0 -> ( "=" FullIdentifier() )+
    */
   public R visit(DiesStatement n, A argu);

   /**
    * f0 -> "synchro"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Block()
    */
   public R visit(SynchonizedStatement n, A argu);

   /**
    * f0 -> "main"
    * f1 -> [ DiesStatement() ]
    * f2 -> Block()
    */
   public R visit(Main n, A argu);

   /**
    * f0 -> "{"
    * f1 -> ( BlockStatement() )*
    * f2 -> "}"
    */
   public R visit(Block n, A argu);

   /**
    * f0 -> EmptyStatement()
    *       | Block()
    *       | Statement()
    *       | ReturnStatement()
    */
   public R visit(BlockStatement n, A argu);

   /**
    * f0 -> DoWhileStatement()
    *       | WhileStatement()
    *       | EachStatement()
    *       | GoStatement()
    *       | IfStatement()
    *       | Label()
    *       | Last() ";"
    *       | Next() ";"
    *       | VariableDeclaration() ";"
    *       | PreInDeCrementExpression() ";"
    *       | InDeCrementExpression() ";"
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ] ";"
    *       | ModuleSubroutineCalling() [ ScalarAssign() ] ";"
    *       | DieStatement() ";"
    *       | JumpStatement() ";"
    *       | EvalStatement()
    *       | SynchonizedStatement()
    */
   public R visit(Statement n, A argu);

   /**
    * f0 -> "~"
    *       | "+"
    *       | "-"
    *       | "#"
    *       | "must"
    */
   public R visit(Modifier n, A argu);

   /**
    * f0 -> ( Modifier() )*
    * f1 -> "module"
    * f2 -> FullIdentifier()
    * f3 -> ModuleBodyBlock()
    */
   public R visit(Module n, A argu);

   /**
    * f0 -> ( Modifier() )*
    * f1 -> VariableDeclaration()
    */
   public R visit(ModuleVariableDeclaration n, A argu);

   /**
    * f0 -> "autoload"
    * f1 -> Block()
    */
   public R visit(ModuleAutoload n, A argu);

   /**
    * f0 -> "init"
    * f1 -> [ "(" [ ParameterType() ( "," ParameterType() )* ] ")" ]
    * f2 -> [ DiesStatement() ]
    * f3 -> Block()
    */
   public R visit(ModuleInit n, A argu);

   /**
    * f0 -> "{"
    * f1 -> ( DollarISA() )?
    * f2 -> ( AtISA() )?
    * f3 -> ( ModuleVariableDeclaration() ";" | SubroutineDeclaration() | ModuleAutoload() | EmptyStatement() | ModuleInit() )*
    * f4 -> "}"
    */
   public R visit(ModuleBodyBlock n, A argu);

   /**
    * f0 -> <DOLLARISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ">"
    */
   public R visit(DollarISA n, A argu);

   /**
    * f0 -> <ATISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ( "," FullIdentifier() )*
    * f4 -> ">"
    */
   public R visit(AtISA n, A argu);

}
