//
// Generated by JTB 1.3.2
//

package alefpp.parser.visitor;
import alefpp.parser.syntaxtree.*;
import java.util.*;

/**
 * All void visitors must implement this interface.
 */

@SuppressWarnings("all")
public interface Visitor {

   //
   // void Auto class visitors
   //

   public void visit(NodeList n);
   public void visit(NodeListOptional n);
   public void visit(NodeOptional n);
   public void visit(NodeSequence n);
   public void visit(NodeToken n);

   //
   // User-generated visitor methods below
   //

   /**
    * f0 -> ( UseStatement() )*
    * f1 -> ( EmptyStatement() | VariableDeclaration() ";" | SubroutineDeclaration() | Module() )*
    * f2 -> ( Main() )?
    * f3 -> <EOF>
    */
   public void visit(Alefpp n);

   /**
    * f0 -> "use"
    * f1 -> <IDENTIFIER>
    * f2 -> ( "." ( <IDENTIFIER> | "*" ) )*
    * f3 -> [ ":" <STRING_LITERAL> ]
    * f4 -> ";"
    */
   public void visit(UseStatement n);

   /**
    * f0 -> ";"
    */
   public void visit(EmptyStatement n);

   /**
    * f0 -> <SPCIAL_SCALAR>
    *       | <SCALAR>
    *       | "$"
    */
   public void visit(Scalar n);

   /**
    * f0 -> "<-"
    * f1 -> Expression()
    */
   public void visit(ScalarAssign n);

   /**
    * f0 -> "my"
    * f1 -> [ "`" ]
    * f2 -> <SCALAR>
    * f3 -> [ FullIdentifier() ]
    * f4 -> ( "@" | "%" )*
    * f5 -> [ ScalarAssign() ]
    */
   public void visit(VariableDeclaration n);

   /**
    * f0 -> "["
    * f1 -> [ ArgumentList() ]
    * f2 -> "]"
    */
   public void visit(Arguments n);

   /**
    * f0 -> Expression()
    * f1 -> ( "," Expression() )*
    */
   public void visit(ArgumentList n);

   /**
    * f0 -> "#"
    * f1 -> ( ModuleSubroutineCalling() | <INTEGER_LITERAL> | Expression() )
    */
   public void visit(ArrayIndex n);

   /**
    * f0 -> "\\"
    * f1 -> ( <IDENTIFIER> | Expression() )
    */
   public void visit(HashKey n);

   /**
    * f0 -> "["
    * f1 -> ( Expression() ( "," Expression() )* )?
    * f2 -> "]"
    */
   public void visit(Array n);

   /**
    * f0 -> "{"
    * f1 -> ( ( <IDENTIFIER> | Expression() ) "=>" Expression() ( "," ( <IDENTIFIER> | Expression() ) "=>" Expression() )* )?
    * f2 -> "}"
    */
   public void visit(Hash n);

   /**
    * f0 -> "->"
    * f1 -> ( <IDENTIFIER> [ Arguments() ] | Scalar() [ ArrayIndex() | HashKey() ] )
    * f2 -> ( MemberAccess() )*
    */
   public void visit(MemberAccess n);

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ( "." <IDENTIFIER> )*
    */
   public void visit(FullIdentifier n);

   /**
    * f0 -> FullIdentifier()
    * f1 -> ( ( "::" )? Arguments() )?
    * f2 -> [ MemberAccess() ]
    */
   public void visit(ModuleSubroutineCalling n);

   /**
    * f0 -> CastStatement()
    *       | ReferenceStatement()
    *       | XiSubroutine()
    *       | ConditionalExpression()
    *       | ConditionalOrExpression()
    *       | AdditiveExpression()
    *       | MultiplicativeExpression()
    *       | BitwiseExpression()
    *       | ShiftExpression()
    *       | Array()
    *       | Hash()
    *       | ValuesExpression()
    */
   public void visit(Expression n);

   /**
    * f0 -> "to"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public void visit(CastStatement n);

   /**
    * f0 -> "ref"
    * f1 -> Expression()
    * f2 -> FullIdentifier()
    */
   public void visit(ReferenceStatement n);

   /**
    * f0 -> ( "+" | "-" )
    * f1 -> ( Expression() )+
    */
   public void visit(AdditiveExpression n);

   /**
    * f0 -> ( "*" | "/" | "%" | "//" | "**" )
    * f1 -> ( Expression() )+
    */
   public void visit(MultiplicativeExpression n);

   /**
    * f0 -> ( "&" | "|" )
    * f1 -> ( Expression() )+
    */
   public void visit(BitwiseExpression n);

   /**
    * f0 -> ( "<<" | ">>" )
    * f1 -> ( Expression() )+
    */
   public void visit(ShiftExpression n);

   /**
    * f0 -> ConditionalAndExpression()
    * f1 -> ( "||" ConditionalAndExpression() )*
    */
   public void visit(ConditionalOrExpression n);

   /**
    * f0 -> EqualityExpression()
    * f1 -> ( "&&" EqualityExpression() )*
    */
   public void visit(ConditionalAndExpression n);

   /**
    * f0 -> RelationalExpression()
    * f1 -> ( ( "==" | "!=" ) RelationalExpression() )*
    */
   public void visit(EqualityExpression n);

   /**
    * f0 -> ExclusiveOrExpression()
    * f1 -> ( ( "<" | ">" | "<=" | ">=" ) ExclusiveOrExpression() )*
    */
   public void visit(RelationalExpression n);

   /**
    * f0 -> ValuesExpression()
    * f1 -> ( "^" ValuesExpression() )*
    */
   public void visit(ExclusiveOrExpression n);

   /**
    * f0 -> "walo"
    */
   public void visit(WaloExpression n);

   /**
    * f0 -> WaloExpression()
    *       | "true"
    *       | "false"
    *       | <STRING_LITERAL>
    *       | <INTEGER_LITERAL>
    *       | <FLOATING_POINT_LITERAL>
    *       | PreInDeCrementExpression()
    *       | InDeCrementExpression()
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ]
    *       | ModuleSubroutineCalling() [ ScalarAssign() ]
    *       | "(" Expression() ")" [ MemberAccess() ]
    *       | "!" Expression()
    */
   public void visit(ValuesExpression n);

   /**
    * f0 -> ( "++" | "--" )
    * f1 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    */
   public void visit(PreInDeCrementExpression n);

   /**
    * f0 -> ( ScalarValue() [ MemberAccess() ] | ModuleSubroutineCalling() )
    * f1 -> ( "++" | "--" )
    */
   public void visit(InDeCrementExpression n);

   /**
    * f0 -> "="
    * f1 -> Expression()
    * f2 -> ","
    * f3 -> ValuesExpression()
    * f4 -> [ "," ValuesExpression() ]
    */
   public void visit(ConditionalExpression n);

   /**
    * f0 -> Scalar()
    * f1 -> ( ArrayIndex() | HashKey() )*
    */
   public void visit(ScalarValue n);

   /**
    * f0 -> "eval"
    * f1 -> BlockStatement()
    * f2 -> ( "error" "(" ( <SCALAR> | "my" <SCALAR> [ FullIdentifier() ] ) ")" BlockStatement() )+
    * f3 -> [ "end" BlockStatement() ]
    */
   public void visit(EvalStatement n);

   /**
    * f0 -> "goto"
    * f1 -> Expression()
    * f2 -> ":"
    * f3 -> BlockStatement()
    */
   public void visit(GotoStatement n);

   /**
    * f0 -> "miss"
    * f1 -> ":"
    * f2 -> BlockStatement()
    */
   public void visit(MissStatement n);

   /**
    * f0 -> "jump"
    * f1 -> Expression()
    * f2 -> ( GotoStatement() )+
    * f3 -> [ MissStatement() ]
    */
   public void visit(JumpStatement n);

   /**
    * f0 -> Expression()
    * f1 -> "!loop"
    * f2 -> BlockStatement()
    */
   public void visit(DoWhileStatement n);

   /**
    * f0 -> Expression()
    * f1 -> "loop"
    * f2 -> BlockStatement()
    */
   public void visit(WhileStatement n);

   /**
    * f0 -> EachInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "each"
    * f4 -> BlockStatement()
    */
   public void visit(EachStatement n);

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ]
    *       | ScalarValue() [ MemberAccess() ]
    *       | ModuleSubroutineCalling()
    */
   public void visit(EachInit n);

   /**
    * f0 -> GoInit()
    * f1 -> ","
    * f2 -> Expression()
    * f3 -> "go"
    * f4 -> [ "(" Expression() ")" ]
    * f5 -> BlockStatement()
    */
   public void visit(GoStatement n);

   /**
    * f0 -> Expression()
    * f1 -> "=>"
    * f2 -> BlockStatement()
    * f3 -> [ "," BlockStatement() ]
    */
   public void visit(IfStatement n);

   /**
    * f0 -> "my" <SCALAR> [ FullIdentifier() ] [ ScalarAssign() ]
    *       | ValuesExpression()
    */
   public void visit(GoInit n);

   /**
    * f0 -> <IDENTIFIER>
    * f1 -> ":"
    */
   public void visit(Label n);

   /**
    * f0 -> "next"
    * f1 -> [ <IDENTIFIER> ]
    */
   public void visit(Next n);

   /**
    * f0 -> "last"
    * f1 -> [ <IDENTIFIER> ]
    */
   public void visit(Last n);

   /**
    * f0 -> FullIdentifier()
    * f1 -> [ ( "[" )+ | ( "@" | "%" )+ ]
    */
   public void visit(ParameterType n);

   /**
    * f0 -> ":"
    * f1 -> FullIdentifier()
    * f2 -> ( ( "[" )+ | ( "@" | "%" )+ )?
    */
   public void visit(SubroutineType n);

   /**
    * f0 -> "sub"
    * f1 -> <IDENTIFIER>
    * f2 -> [ SubroutineType() ]
    * f3 -> ( "(" [ ParameterType() ( "," ParameterType() )* ] ")" )?
    * f4 -> [ DiesStatement() ]
    * f5 -> Block()
    */
   public void visit(SubroutineDeclaration n);

   /**
    * f0 -> Block()
    * f1 -> Arguments()
    */
   public void visit(XiSubroutine n);

   /**
    * f0 -> "ret"
    * f1 -> Expression()
    * f2 -> ";"
    */
   public void visit(ReturnStatement n);

   /**
    * f0 -> "die"
    * f1 -> Expression()
    */
   public void visit(DieStatement n);

   /**
    * f0 -> ( "=" FullIdentifier() )+
    */
   public void visit(DiesStatement n);

   /**
    * f0 -> "synchro"
    * f1 -> "("
    * f2 -> Expression()
    * f3 -> ")"
    * f4 -> Block()
    */
   public void visit(SynchonizedStatement n);

   /**
    * f0 -> "main"
    * f1 -> [ DiesStatement() ]
    * f2 -> Block()
    */
   public void visit(Main n);

   /**
    * f0 -> "{"
    * f1 -> ( BlockStatement() )*
    * f2 -> "}"
    */
   public void visit(Block n);

   /**
    * f0 -> EmptyStatement()
    *       | Block()
    *       | Statement()
    *       | ReturnStatement()
    */
   public void visit(BlockStatement n);

   /**
    * f0 -> DoWhileStatement()
    *       | WhileStatement()
    *       | EachStatement()
    *       | GoStatement()
    *       | IfStatement()
    *       | Label()
    *       | Last() ";"
    *       | Next() ";"
    *       | VariableDeclaration() ";"
    *       | PreInDeCrementExpression() ";"
    *       | InDeCrementExpression() ";"
    *       | ScalarValue() [ MemberAccess() ] [ ScalarAssign() ] ";"
    *       | ModuleSubroutineCalling() [ ScalarAssign() ] ";"
    *       | DieStatement() ";"
    *       | JumpStatement() ";"
    *       | EvalStatement()
    *       | SynchonizedStatement()
    */
   public void visit(Statement n);

   /**
    * f0 -> "~"
    *       | "+"
    *       | "-"
    *       | "#"
    *       | "must"
    */
   public void visit(Modifier n);

   /**
    * f0 -> ( Modifier() )*
    * f1 -> "module"
    * f2 -> FullIdentifier()
    * f3 -> ModuleBodyBlock()
    */
   public void visit(Module n);

   /**
    * f0 -> ( Modifier() )*
    * f1 -> VariableDeclaration()
    */
   public void visit(ModuleVariableDeclaration n);

   /**
    * f0 -> "autoload"
    * f1 -> Block()
    */
   public void visit(ModuleAutoload n);

   /**
    * f0 -> "init"
    * f1 -> [ "(" [ ParameterType() ( "," ParameterType() )* ] ")" ]
    * f2 -> [ DiesStatement() ]
    * f3 -> Block()
    */
   public void visit(ModuleInit n);

   /**
    * f0 -> "{"
    * f1 -> ( DollarISA() )?
    * f2 -> ( AtISA() )?
    * f3 -> ( ModuleVariableDeclaration() ";" | SubroutineDeclaration() | ModuleAutoload() | EmptyStatement() | ModuleInit() )*
    * f4 -> "}"
    */
   public void visit(ModuleBodyBlock n);

   /**
    * f0 -> <DOLLARISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ">"
    */
   public void visit(DollarISA n);

   /**
    * f0 -> <ATISA>
    * f1 -> "<"
    * f2 -> FullIdentifier()
    * f3 -> ( "," FullIdentifier() )*
    * f4 -> ">"
    */
   public void visit(AtISA n);

}

