/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.plugins.methods.proxy;

import java.lang.reflect.InvocationHandler;

import alefpp.reflect.Reflection;

/**
 * Plug-in to using a Java proxies (interfaces)
 * @author Adrabi Abderrahim
 * @version 1.1
 */

public class Proxy {
	
	private Proxy(){
		
	}
	
	/**
	 * 
	 * @param $1 (String  : Method Name)
	 * @param $2 (Object  : Interpreter)
	 * @param $3 (String[]: Values) 
	 * @return
	 * @throws ClassNotFoundException 
	 */
	public static Object forge(String $1, Object $2, Object ... $3) throws ClassNotFoundException{
		
		Class _interface_ = Class.forName( Reflection.fullIdentifier( $3[0].toString() ) );
		
		InvocationHandler handler = new AlefppInvocationHandler($2, (String[]) $3 );
		
		//~ return a value
		return java.lang.reflect.Proxy.newProxyInstance
		(
				_interface_.getClassLoader(), 
				new Class[]{ _interface_ },
				handler
		);
		
	}
}
