/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.reflect;

import alefpp.core.Walo;

/**
 * Create a class type from string type
 * @author Adrabi Abderrahim
 * @version 1.1
 */

public class ClassType {
	
	/**
	 * Get Class object from specified type
	 * @param $1 (String : Type Name)
	 * @return
	 * @throws ClassNotFoundException
	 */
	public static Class forgeClass(String $1) throws ClassNotFoundException{
		if( $1 == null ){
			return Walo.class;
		}
		else if( $1.equals("-I") || $1.equals("int")){
			return int.class ;
		}
		else if( $1.equals("-L") || $1.equals("long") ){
			return long.class ;
		}
		else if( $1.equals("-D") || $1.equals("double") ){
			return double.class ;
		}
		else if( $1.equals("-Z") || $1.equals("boolean")){
			return boolean.class ;
		}
		else if( $1.equals("-W") ){
			return null;
		}else{
			return Class.forName($1);
		}
	}
}
