/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.reflect;

import java.lang.reflect.Field;
import alefpp.core.AValue;

/**
 * Class base of field manipulation by reflection
 * @author Adrabi Abderrahim
 * @version 1.1
 */

public class Scalar {
	
	/**
	 * Check existence of the field 
	 * @param $1 (Object : Class Object)
	 * @param $2 (String : Filed Name)
	 * @return
	 */
	@SuppressWarnings("unchecked")
	public boolean existsField(Object $1, String $2){
		//~ Public Field
		try{
			Class clazz = $1 instanceof Class ? (Class)$1 : $1.getClass();
			clazz.getField($2);
			
			return true;
			
		}catch (SecurityException e) {
		
		} catch (NoSuchFieldException e) {
			
		}
		
		//~ Private or Protected Field
		try{
			Class clazz = $1 instanceof Class ? (Class)$1 : $1.getClass();
			clazz.getDeclaredField($2);
			
			return true;
			
		}catch (SecurityException e) {
		
		} catch (NoSuchFieldException e) {
			
		}
		return false;
	}
	
	/**
	 * Return a field object from spicified class name for statics
	 * @param $1 (String : Class Name)
	 * @param $2 (String : Field Name)
	 * @return
	 */
	public Object getFieldObject(String $1 , String $2){
		//~ Public Field
		try{
			Class clazz = ClassType.forgeClass($1);
			return clazz.getField($2).get(clazz);
		}catch(ClassNotFoundException cnfe){
			
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		
		//Private or Protected Filed
		try{
			Class clazz = ClassType.forgeClass($1);
			Field field = clazz.getDeclaredField($2);
			field.setAccessible(true);
			return field.get(clazz);
		}catch(ClassNotFoundException cnfe){
			
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		return null;
	}
	
	/**
	 * Return a field object from spicified class name for statics
	 * @param $1 (Object : Class Object)
	 * @param $2 (String : Field Name)
	 * @return
	 */
	public Object getFieldObject(Object $1 , String $2){
		//~ Public Field
		try{
			Field field = $1.getClass().getField($2);
			return field.get($1);
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		
		//~ Private or Protected Field
		try{
			Field field = $1.getClass().getDeclaredField($2);
			field.setAccessible(true);
			return field.get($1);
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		return null;
	}
	
	/**
	 * Set a field object from spicified class name for statics
	 * @param $1 (String : Class Name)
	 * @param $2 (String : Field Name)
	 * @return
	 */
	public Object setFieldObject(String $1 , String $2, AValue $3){
		//~ Public Field
		try{
			Class clazz = ClassType.forgeClass($1);
			Field field = clazz.getField($2);
			field.set(clazz, $3.getValue());
			return field.get(clazz);
		}catch(ClassNotFoundException cnfe){
			
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		
		//Private or Protected Filed
		try{
			Class clazz = ClassType.forgeClass($1);
			Field field = clazz.getDeclaredField($2);
			field.setAccessible(true);
			field.set(clazz, $3.getValue());
			return field.get(clazz);
		}catch(ClassNotFoundException cnfe){
			
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		return null;
	}
	
	/**
	 * Set a field object from spicified class name for statics
	 * @param $1 (Object : Class Object)
	 * @param $2 (String : Field Name)
	 * @return
	 */
	public Object setFieldObject(Object $1 , String $2, AValue $3){
		//~ Public Field
		try{
			Field field = $1.getClass().getField($2);
			field.set($1, $3.getValue());
			return field.get($1);
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		
		//~ Private or Protected Field
		try{
			Field field = $1.getClass().getDeclaredField($2);
			field.setAccessible(true);
			field.set($1, $3.getValue());
			return field.get($1);
		}catch(IllegalAccessException iae){
			
		}catch(NoSuchFieldException nsfe){
			
		}
		return null;
	}
	
}
