/**
 *     _    _       __             
 * 	  / \  | | ___ / _|  _     _   
 *	 / _ \ | |/ _ \ |_ _| |_ _| |_ 
 *	/ ___ \| |  __/  _|_   _|_   _|
 * /_/   \_\_|\___|_|   |_|   |_|  
 *
 * Author	:: Adrabi Abderrahim
 * Mail		:: Adrabi[at]Gmail[dot]Com
 * License	:: files Artistic.htm, GPL.htm
 */

package alefpp.tools;

import alefpp.core.AArray;
import alefpp.core.AValue;

/**
 * 
 * @author Adrabi Abderrahim
 *
 */
public class Tools {
	
	/**
	 * Build a Alef++ arrays from Java native arrays
	 * @param $1 (Object : Native Java Array)
	 * @return
	 */
	public static Object to_a_a(Object $1){
		
		AArray<Object> array = new AArray<Object>();
		
		if( $1.getClass().isArray() ){
			for( Object val : (Object[])$1 ){
				if( val.getClass().isArray() ){
					array.push( to_a_a( val ) );
				}
				else{
					array.push( new AValue( null, Types.getObjectType( val ) , val ) );
				}
			}
		}
		
		return array;
	}
	
	public static Object to_a_a(AValue $1){
		return to_a_a( $1.getValue() );
	}
	
	public static int ord(String $1){
		if( $1.length() == 0 ) return -1;
		return ord($1.charAt(0));
	}
	
	public static int ord(char $1){
		return (int)$1;
	}
	
	public static char chr(int $1){
		return (char)$1;
	}
}
