__________________________________________________
__						__
__	    _    _       __             	__
__ 	   / \  | | ___ / _|  _     _   	__
__	  / _ \ | |/ _ \ |_ _| |_ _| |_ 	__
__	 / ___ \| |  __/  _|_   _|_   _|	__
__	/_/   \_\_|\___|_|   |_|   |_|  	__
__						__
__ Author	:: Adrabi Abderrahim		__
__ Mail		:: Adrabi[at]Gmail[dot]Com	__
__ License	:: files Artistic.htm, GPL.htm	__
__________________________________________________

use java.lang.*;
use java.awt.*;
use java.awt.event.*;
use javax.swing.*;
use java.io.*;

__ Global variables
my $frame	JFrame		;
my $editArea	JTextArea	;

__ Open File
sub open_actionPerformed{
	my $fileChooser	JFileChooser <- JFileChooser::[];
	my $retval <- $fileChooser->showOpenDialog[ $frame ];
    $retval == (JFileChooser->APPROVE_OPTION) => {
        my $f  <- $fileChooser->getSelectedFile[];
        eval {
              my $reader FileReader <- FileReader::[ to $f File ];
              $editArea->read[ $reader , '' ];
                 
        } error ( my $ioex IOException ) {
            System->out->println[ $ioex ];
            System->exit[ 1 ];
        }
    }
}

__ Save File
sub save_actionPerformed{
	my $fileChooser	JFileChooser <- JFileChooser::[];
	my $retval int <- $fileChooser->showSaveDialog[ $frame ];
    $retval == JFileChooser->APPROVE_OPTION => {
    	my $f <- $fileChooser->getSelectedFile[] ;
        eval {
        	my $writer FileWriter <- FileWriter::[ to $f File ];
            $editArea->write[ $writer ]; 
        } error ( my $ioex IOException) {
            JOptionPane->showMessageDialog[ $frame, $ioex ];
            System->exit[ 1 ];
        }
    }
}

__ Exit
sub exit_actionPerformed{
	 System->exit[ 0 ];
}

main{
	$frame	<- JFrame::[];
		
	$editArea <- JTextArea::[15, 80];
        $editArea->setBorder[ BorderFactory->createEmptyBorder[ 2,2,2,2 ] ];
        $editArea->setFont[ Font::[ 'monospaced', Font->PLAIN, 14 ] ];
        
        my $scrollingText JScrollPane <- JScrollPane::[ $editArea ];
        
        __ Create a content pane, set layout, add component.
        my $content JPanel <- JPanel::[];
        $content->setLayout[ BorderLayout::[] ];
        $content->add[ $scrollingText ];
        
        __ Create menubar
        my $menuBar JMenuBar <- JMenuBar::[];
        
        my $fileMenu JMenu <-  $menuBar->add[ JMenu::['File'] ];
        
        __ Open file
        my $open JMenuItem <- JMenuItem::['Open' , KeyEvent->VK_O];
        $open->addActionListener[ proxy[ 'ActionListener' , 'actionPerformed:open_actionPerformed' ] ];
        $fileMenu->add[ $open ];
        
        __ Save file
        my $save JMenuItem <- JMenuItem::['Save' , KeyEvent->VK_S];
        $save->addActionListener[ proxy[ 'ActionListener' , 'actionPerformed:save_actionPerformed' ] ];
        $fileMenu->add[ $save ];
        
        __ Separator
        $fileMenu->addSeparator[];
        
        __ Exit file
        my $exit JMenuItem <- JMenuItem::['Exit' , KeyEvent->VK_E];
        $exit->addActionListener[ proxy[ 'ActionListener' , 'actionPerformed:exit_actionPerformed' ] ];
        $fileMenu->add[ $exit ];
        
        __ Set window content and menu.
        $frame->setContentPane[ $content ];
		$frame->setJMenuBar[ $menuBar ];
        
        __ Set other window characteristics.
        
        $frame->setDefaultCloseOperation[ JFrame->EXIT_ON_CLOSE ];
        $frame->setTitle[ 'NutPad' ];
        $frame->pack[];
        __$frame->setLocationRelativeTo[ null ];
        $frame->setVisible[ true ];
}
